package com.localtransfer;

import android.content.ContentUris;
import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
import android.provider.MediaStore;
import android.widget.Button;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class TransferFile {

    private Integer id;

    public String name;

    public String href;

    public String mime;

    public String type;

    public long size;

    public String save_location;

    public Uri uri;

    public Button button;

    public Progress progress;

    private static List<TransferFile> instances = new ArrayList<>();

    public TransferFile(Integer id) {
        this.id = id;
        instances.add(this);
    }

    public static List getInstances() {
        return instances;
    }

    public static TransferFile getDownload(int id) {
        for (Object obj: instances) {
            TransferFile p = (TransferFile) obj;
            if (p.id == id) return p;
        }
        return null;
    }

    public Integer getId() {
        return id;
    }

    public boolean exist(Context context) {
        if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.Q) {
            Cursor cursor = context.getContentResolver().query(MediaStore.Downloads.EXTERNAL_CONTENT_URI, null, null, null, null);
            while (cursor.moveToNext()) {
                String MediaStore_File_name = cursor.getString(cursor.getColumnIndexOrThrow(MediaStore.Downloads.DISPLAY_NAME));
                long MediaStore_File_size = cursor.getLong(cursor.getColumnIndexOrThrow(MediaStore.Downloads.SIZE));
                if(MediaStore_File_name.equals(name) && MediaStore_File_size == size) {
                    int cursor_id = cursor.getInt(cursor.getColumnIndexOrThrow(MediaStore.Downloads._ID));
                    uri = ContentUris.withAppendedId(MediaStore.Downloads.EXTERNAL_CONTENT_URI, cursor_id);
                    return true;
                }
            }
        }
        else {
            File file = new File(save_location, name);
            new File(save_location).mkdirs();
            uri = Uri.fromFile(file);
            if (file.exists() && file.length() == size)
                return true;
        }
        return false;
    }
}
